# Reforge Praying System

<p align="center">
  <a href="https://discord.gg/uS5P3HuGCT">
    <img src="https://media.discordapp.net/attachments/1075550551485464586/1094662243217580093/Krumpac_Wallapaper_3.png?width=1630&height=917">
  </a>
  <br/>
  <a href="https://discord.gg/uS5P3HuGCT">
    <img src="https://cdn.discordapp.com/attachments/1082990529110872074/1082990993885892678/Krump_Logo_NEW_04.png">
  </a>
  <br/>
  Krumpac Modding Discord
</p>

# DISCLAIMER - BETA test phase - READ THIS FIRST!!!

**Since the mod pack is currently under development, playing the BETA is only available for closed community members!**

For being able to play the mod pack, you will need to APPLY and BE APPROVED to become a closed BETA community member.
Please fill in the form [Krumpac Reforge Beta Tester Application](https://forms.gle/f1pwtvAhECbf3TuR7). We will review
the requests on best effort base (don't except immediate answers). We will only select small amounts of people to be
part of this BETA testing phase.

NOTE: Being accepted to the closed community for BETA testing is not influenced by becoming a Patreon supporter or any
other financial support given. Same as being part of the closed community does not imply to need to financially support
the community or authors. **THERE WILL BE NO PAYWALL FOR THIS MOD, JUST A REGISTRATION.**

**WARNING**: without being an APPROVED member of the closed BETA testing community, installing the mod pack will be
possible, but you will not be able to launch the game and mods will not load!

# Copyright, permissions and credits

Due to the recent discussions started from IronGate (publisher of Valheim) about the intent of free modding and paid
modding, there was a big change in how we distribute the Reforge mods and we also update the terms of how they can be
used more clearly with the following statements.

Copyright and all rights reserved stay with the original author (uploader of this mod / mod pack) of Reforge and all
mods affiliated with it directly.

## Credits and distribution permission

* Other user's assets: All the assets in this file belong to the author, or are from free-to-use modder's resources
* Upload permission: You are NOT allowed to upload the files contained in this mod / mod pack to other sites under any
  circumstances
* Modification permission: You are NOT allowed to modify my files to improve them in any circumstances
    * Exception: files used for configuring the mods are allowed to be tailored to your needs: `*.cfg`, `*.txt`,
      and `*.yml` (or `*.yaml`)
* Conversion permission: You are NOT allowed to convert the files of this mod / mod pack to work on other games under
  any circumstances
* Asset use permission: You are NOT allowed to use any of the assets in the files of this mod / mod pack
* Asset use permission in mods/files that are being sold: You are NOT allowed to use assets from this file in any
  mods/files that are being sold, for money, on Steam Workshop or other platforms
* Asset use permission in mods/files that earn donations: You are NOT allowed to earn donations for your mods if they
  use my assets

# Installation

* To make sure all mods work as designed it is highly recommended to download
  the [CORE mod pack](https://valheim.thunderstore.io/package/Krumpac/Krumpac_Reforge_Core/) **including** all
  dependencies.
* Reforged makes so many changes to the game (mainly with materials and crafting stations) that some mods that rely on
  the vanilla materials and items may not work. The good news is that most QoL mods won't have compatibility issues *
  **but we recommend that you start a new world with a new character, then add your preferred QoL slowly to ensure
  compatibility.**

**WARNING**: downloading this mod pack using *R2 Mod Manager* will cause the mod pack to not work fully, you might be
affected by some issues of missing configurations!

# Praying System Features

## Short description

To use the Praying System (coming with a Praying Skill), open the in-game chat and type `/pray`. This will start the
player to knee down and pray (including animation, music, etc.). There are different types of prayers, like you can pray
at any place in the game in the whole world (where gods do listen to you - configuration), or you can try to find an
Reforge Sacrificing Altar to pray there to the specific god of the altar.

But beware, sometimes the gods will not like your prayer and might be wanting to punish you (the gods are moody some
times). On a successful prayer you will be rewarded in different ways, on unsuccessful prayers you might get ignored or
even punished in different ways.

## Detailed description

The Praying System uses a complex configuration to enable different settings for chances of success and failure, on what
will happen in each of them depending on biome and even location you are at while praying.

Praying can affect:

- Getting a de-/buff
- Offerings turned into gifts by the gods (only praying at an altar)
- Extending your Rested Buff
- Weather Change
- Spawned items
- Spawned Creatures
- Death (only when praying at an altar and in rare cases - its called bad luck)

The Praying System comes with a couple of Status Effects (de-/buffs / cooldown):

- Blessed Buff ("God's blessing: +10% attack speed +10% attack damage +10% health regen")
- Cursed Debuff ("God's curse: -20% attack speed -20% attack damage -20% health regen")
- Praying Cooldown (until when you can pray in the World next time)
- Praying Cooldown Altar (until when you can pray at an Altar next time)
- Weather (until when the weather is controlled by the prayer result)

The Praying System does log to console, in-game via Status Logs (top left) and bigger notifications to the player (
central).

### How Offerings at Sacrificing Altars work

When praying at a Sacrificing Altar, the player can carry some offerings to the gods in his inventory. When praying at
the altar was successful, the offerings will be removed from the player's inventory and respective gifted items will be
dropped. You will need to check the ground in-front of you after praying to pick up the items.

### Configuration

Praying System comes with 2 types of config:

* Krumpac_Praying_System.cfg -> central and global configurations
* Krumpac_Praying_System.yaml -> configurations per biome and locations

The YAML file comes with config already in place, in case you want to change something, make sure to follow the given
schema:

* PrayerDuration
    * World
    * Altar
* PrayerTypes
    * "Name of the prayer type" with the schema like for example:
        * Type: World or Altar
        * Cooldown: 600 - number of seconds cooldown until next prayer
        * ResultType: CriticalSuccess / Success / Failure / CriticalFailure
        * ChancePercentBottom: 95 -> means any dice roll (0 to 100) has only 5% chance to match this category, like
          rolling 96
        * SkillGain: 16 -> skill points that will be added to the praying skill if this category was matched
* BiomeTypes
    * "Biome Name" (Meadows / BlackForest / Ocean / Swamp / Mountain / Plains / Mistlands / AshLands / DeepNorth) with
      content following this schema:
        * MinimumPrayingLevel: 10 -> only with skill from level 10 you can pray in this biome
        * PrayingResults:
            * Type: CriticalFailed
            * SetWeather: Eikthyr
            * SpawnCreature: (list of objects to spawn by chance)
                * PrefabName: Krump_Monster_Neck_Brute
                * Amount: 2
                * ChancePercent: 90
            * SpawnItem: (same as SpawnCreature - list of objects to spawn by chance)
                * ...
        * BiomeLocations
            * "location name" (for example "Krump_Altar_Meadows_Bragi")
                * PrayingResults: (same as above)
                * OfferingsForGifts:
                    * "Name of the offering" (for example BloodBowlForSeeds):
                        * OfferedItem: Krump_Mat_Offering_BloodBowl_Meadows (prefab name of the item the player needs to
                          have in the inventory during praying and that will be removed by praying on success)
                        * OfferedAmount: 1
                        * GiftedItem: Krump_Mat_Altar_Seed_Meadows (prefab name of the item to be dropped by successful
                          praying)
                        * GiftedAmount: 15

# You Like it? You Love it? Support me :)

## Discord

Leave a comment on [Discord](https://discord.gg/uS5P3HuGCT)

## Buy me a coffee

You can support me to not fall asleep during the long nights of modding
by [buying me a coffee](https://www.buymeacoffee.com/krumpacmodding) :)

## Paypal

You can also offer me a cold
<a href="https://www.paypal.com/paypalme/KrumpacModding">
<img src="https://cdn.discordapp.com/emojis/1081671887375048754.gif?size=96&quality=lossless">
</a>

<p align="center">
  <img src="https://cdn.discordapp.com/attachments/1082990529110872074/1090971792346185799/Krumpac_PayPal.png">
</p>

## Patreon

If you would like more Creations & Content, consider to support me as a Patreon for the rest of my stuffs

<p align="center">
  <a href="https://www.patreon.com/KrumpacModding">
    <img src="https://media.discordapp.net/attachments/1082990529110872074/1082997636874911855/Patreon-logo.png?width=1630&height=917">
  </a>
</p>

# Protected by KeyManager

[![KeyManager Disclaimer](https://noobtrap.eu/images/keymanager_disclaimer.png)](https://key.sayless.eu/faq.php)

# Miscellaneous

## Special Thanks

### Our music creators

* `Eolya#1009` on [Youtube](https://www.youtube.com/@Eolya)
* `Ivan Duch#8102` on [YoutTube](https://www.youtube.com/@IvanDuch)

## Contact

<details>
  <summary>Contact</summary>

* [Discord Server](https://discord.gg/uS5P3HuGCT)
* [Patreon](https://www.patreon.com/KrumpacModding)
* [YouTube KrumpacModding](https://www.youtube.com/@KrumpacModding)

</details>
